#!/usr/bin/env python
#===========================================================================
#Python RTC Connector Module Header
#===========================================================================
#Author:
#Written by Takayuki Sugawara, Univ of Tsukuba
#===========================================================================
#Version Information: 2007/12/10
#Ver. 1.0: Convert the ConnectorComp program(C++ Version) to Python
#===========================================================================
#Explanation about this module:
#This module provides you to control the RT Component using the python.
#===========================================================================

import sys
import time
from omniORB import CORBA
import omniORB.any
import CosNaming
import RTC
import SDOPackage

#com_name = ['','','','','','','','','','']

#Components = ['','','','','','','','','','']
#Lists = ['','','','','','','','','','']
#Activity = ['','','','','','','','','','']

com_name = ['','','','','','','','','','','','','','','','','','','']

Components = ['','','','','','','','','','','','','','','','','','','']
Lists = ['','','','','','','','','','','','','','','','','','','']
Activity = ['','','','','','','','','','','','','','','','','','','']


Components2 = ['','','','','','','','','','']
Lists2 = ['','','','','','','','','','']
Activity2 = ['','','','','','','','','','']

class RTCConnector:

      	#Initialization of CORBA Object
	def __init__(self):
		self.orb = CORBA.ORB_init(sys.argv, CORBA.ORB_ID)
	#Connect to specified nameservice
	#=====argument=====
	#serveradd: Nameserver address and port number
	def	Connect2Nameservice(self,serveradd):
		orb = self.orb
		nameservice = "corbaloc::" + serveradd + "/NameService"
		obj = orb.string_to_object(nameservice)
		self.rootContext = obj._narrow(CosNaming.NamingContext)
		if self.rootContext is None:
   			print "Failed to narrow the root naming context"
   			sys.exit(1)

        #Get component list from nameserver
	def GetComponentLists(self):
		i = 0;
		try:
			lists = self.rootContext.list(100)
		except:
			print "Cannot get component lists"
			return
		for ci in lists[0]:
		    com_name[i] =  ci.binding_name[0].id

		    if ci !=None:
		        try:
#				print "ComponentID:"+ci.binding_name[0].id
#				print "ComponentKind:"+ci.binding_name[0].kind
#				print '\n'
				i = i+1;

			except:
				print "No Component"
				break


	#Get target object reference from specified nameservice
	#=====argument=====
	#component_name: component name
	def GetObjectReference(self,component_name):
		rootContext = self.rootContext
		name = [CosNaming.NameComponent(component_name, "rtc")]
		obj = rootContext.resolve(name)
		ObjectReference = obj._narrow(RTC.RTObject)
		if (ObjectReference is None):
   			print "Object reference is not an RTC::RTObject"
   			sys.exit(1)
		return ObjectReference

	#Get profile of target component
	#=====argument=====
	#ObjRef: Object reference to be able to get calling GetObjectReference
	def GetComponentProfile(self,ObjRef):
		return ObjRef.get_component_profile()

	#Get object of target component
	#=====argument=====
	#ObjRef: Object reference to be able to get calling GetObjectReference
	def GetPortsObject(self,ObjRef):
		return ObjRef.get_ports()
#		return ObjRef.get_port_profile()

	#Get execution context of target component
	#=====argument=====
	#ObjRef: Object reference to be able to get calling GetObjectReference
	def GetExecutionContextServices(self,ObjRef):
	    return ObjRef.get_execution_context_services()

	#Connect the each specified components
	#=====argument=====
	#ComAPortsObject: PortsList which is return value from
	#                 GetPortsObject
	#ComBPortsObject: PortsList which is return value from
	#                 GetPortsObject
	def PortConnect(self,ComAPortsObject,ComBPortsObject):
	    ports = [ComAPortsObject, ComBPortsObject]
	    props = []
	    props.append(SDOPackage.NameValue("dataport.interface_type", omniORB.any.to_any("CORBA_Any")))
	    props.append(SDOPackage.NameValue("dataport.dataflow_type", omniORB.any.to_any("Push")))
	    props.append(SDOPackage.NameValue("dataport.subscription_type", omniORB.any.to_any("Flush")))
	    ConnectProf = RTC.ConnectorProfile("connector0","", ports, props)
	    ret, prof = ComAPortsObject.connect(ConnectProf)

	def PortDisconnect(self,ComAPortsObject):
	    ComAPortsObject.disconnect_all()
